<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\external;


use app\common\model\external\ExternalPlatformGoods;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * ExternalPlatformGoods逻辑
 * Class ExternalPlatformGoodsLogic
 * @package app\adminapi\logic
 */
class ExternalPlatformGoodsLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/03/21 19:09
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            ExternalPlatformGoods::create([
                'service_fee' => $params['service_fee'],
                'goods_status' => $params['goods_status'],
                'goods_id' => $params['goods_id'],
                'external_goods_sn' => $params['external_goods_sn'],
                'external_platform_id' => $params['external_platform_id'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/03/21 19:09
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            ExternalPlatformGoods::where('id', $params['id'])->update([
                'service_fee' => $params['service_fee'],
                'goods_status' => $params['goods_status'],
                'goods_id' => $params['goods_id'],
                'external_goods_sn' => $params['external_goods_sn'],
                'external_platform_id' => $params['external_platform_id'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/03/21 19:09
     */
    public static function delete(array $params): bool
    {
        return ExternalPlatformGoods::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2025/03/21 19:09
     */
    public static function detail($params): array
    {
        return ExternalPlatformGoods::findOrEmpty($params['id'])->toArray();
    }

    public static function goodsImport($datas)
    {
        $newArray = [];
        $time = time();
        foreach ($datas as $key => $data) {
            $newArray[$key]['service_fee'] = $data['service_fee']?:0;
            $newArray[$key]['goods_status'] = 1;
            $newArray[$key]['create_time'] = $time;
            $newArray[$key]['update_time'] = $time;
            $newArray[$key]['goods_id'] = $data['goods_id'];
            $newArray[$key]['external_goods_sn'] = $data['external_goods_sn'];
            $newArray[$key]['external_platform_id'] = $data['external_platform_id'];
        }

        Db::startTrans();
        try {

            ExternalPlatformGoods::insertAll($newArray);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


}